package dev.shadowsoffire.apotheosis.ench.replacements;

package .tmp;

import net.minecraft.tags.DamageTypeTags;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.item.enchantment.Enchantments;
import net.minecraft.world.item.enchantment.ProtectionEnchantment;

public class DefenseEnchant extends ProtectionEnchantment {
  public DefenseEnchant(Enchantment.Rarity rarity, ProtectionEnchantment.Type type, EquipmentSlot... slots) {
    super(rarity, type, slots);
  }
  
  public int m_7205_(int level, DamageSource source) {
    if (source.m_269533_(DamageTypeTags.f_268738_))
      return 0; 
    if (this.f_45124_ == ProtectionEnchantment.Type.ALL)
      return level; 
    if (this.f_45124_ == ProtectionEnchantment.Type.FIRE && source.m_269533_(DamageTypeTags.f_268745_))
      return level; 
    if (this.f_45124_ == ProtectionEnchantment.Type.FALL && source.m_269533_(DamageTypeTags.f_268549_))
      return level * 3; 
    if (this.f_45124_ == ProtectionEnchantment.Type.EXPLOSION && source.m_269533_(DamageTypeTags.f_268415_))
      return level * 2; 
    return (this.f_45124_ == ProtectionEnchantment.Type.PROJECTILE && source.m_269533_(DamageTypeTags.f_268524_)) ? level : 0;
  }
  
  public boolean m_5975_(Enchantment ench) {
    if (this == Enchantments.f_44967_ || this == Enchantments.f_44965_)
      return (ench != this); 
    if (ench instanceof ProtectionEnchantment) {
      ProtectionEnchantment pEnch = (ProtectionEnchantment)ench;
      if (ench == this)
        return false; 
      return (pEnch.f_45124_ == ProtectionEnchantment.Type.ALL || pEnch.f_45124_ == ProtectionEnchantment.Type.FALL);
    } 
    return (ench != this);
  }
}
